@echo off
REM $Id: startos.bat 998 2008-07-16 12:24:46Z Sergej $
REM reset user hive, check for locked files and startOS

if not "%RSDRV%"=="" goto RSDRV_
SET RSDRV=c:
:RSDRV_
if not "%CEDRV%"=="" goto CEDRV_
SET CEDRV=d:
:CEDRV_

doslfn

set SYSTEM_HIVE_DIR=%RSDRV%\DOCUME~1
set SYSTEM_HIVE=system.hv
set SYSTEM_HIVE_FILE=%SYSTEM_HIVE_DIR%\%SYSTEM_HIVE%

set USER_HIVE_DIR=%SYSTEM_HIVE_DIR%\default
set USER_HIVE=user.hv
set USER_HIVE_FILE=%USER_HIVE_DIR%\%USER_HIVE%

set HIVE_STARTUP_MARK=%CEDRV%\hive.def
set FACTORY_DEFAULT_MARK=%CEDRV%\factory.def

set DEVICE_LOG=%CEDRV%\DM\device.log

echo Start OS log >> %DEVICE_LOG%
date /D >> %DEVICE_LOG%
time /T >> %DEVICE_LOG%

if not exist %HIVE_STARTUP_MARK% goto HIVE_
echo Keep Hive repository to %CEDRV%\ partition. >> %DEVICE_LOG%

copy /B %SYSTEM_HIVE_FILE% %CEDRV%\%SYSTEM_HIVE% /Y /V >> %DEVICE_LOG%
copy /B %USER_HIVE_FILE% %CEDRV%\%USER_HIVE% /Y /V >> %DEVICE_LOG%
del %HIVE_STARTUP_MARK% /V >> %DEVICE_LOG%

if not exist %FACTORY_DEFAULT_MARK% goto FACTORY_
del %FACTORY_DEFAULT_MARK% /V >> %DEVICE_LOG%
goto FACTORY_

:HIVE_

if not exist %FACTORY_DEFAULT_MARK% goto FACTORY_
echo Resetting User hive to factory default settings. >> %DEVICE_LOG%

copy /B %CEDRV%\%SYSTEM_HIVE% %SYSTEM_HIVE_FILE% /Y /V >> %DEVICE_LOG%
copy /B %CEDRV%\%USER_HIVE% %USER_HIVE_FILE% /Y /V >> %DEVICE_LOG%
rem del %FACTORY_DEFAULT_MARK% /V >> %DEVICE_LOG%

:FACTORY_

set SYSTEM_HIVE_DIR=
set SYSTEM_HIVE=
set SYSTEM_HIVE_FILE=
set USER_HIVE_DIR=
set USER_HIVE=
set USER_HIVE_FILE=
set HIVE_STARTUP_MARK=
set FACTORY_DEFAULT_MARK=

REM Check %CEDRV%\ for lock folder
set LOCK_DIR=%CEDRV%\lock
set PARENT_DIR=%CEDRV%
set NEXT_LOCK_DIR=CE

:CheckLockDIR
if not exist %LOCK_DIR%\*.* goto %NEXT_LOCK_DIR%check
echo Locked file handler... >> %DEVICE_LOG%
echo Lock file folder: %LOCK_DIR% >> %DEVICE_LOG%
echo Parent Lock file folder: %PARENT_DIR%\ >> %DEVICE_LOG%
dir %LOCK_DIR% /B >> %DEVICE_LOG%

echo attempt move... >> %DEVICE_LOG%
move /Y /V  %LOCK_DIR%\*.* %PARENT_DIR%\. >> %DEVICE_LOG%

if not exist %LOCK_DIR%\*.* goto MoveComplete
echo attempt copy... >> %DEVICE_LOG%
copy /B %LOCK_DIR%\*.* %PARENT_DIR%\. /Y /V >> %DEVICE_LOG%

echo deleting files... >> %DEVICE_LOG%
del %LOCK_DIR%\*.* /V >> %DEVICE_LOG%

:MoveComplete
if not exist %LOCK_DIR%\*.* echo %LOCK_DIR% is now empty. >> %DEVICE_LOG%
goto %NEXT_LOCK_DIR%check

:CEcheck
REM Check %CEDRV%\CE for lock folder
set LOCK_DIR=%CEDRV%\CE\lock
set PARENT_DIR=%CEDRV%\CE
set NEXT_LOCK_DIR=Done
goto CheckLockDIR

:Donecheck
echo Locked file handler is finished >> %DEVICE_LOG%
time /T >> %DEVICE_LOG%
set LOCK_DIR=
set PARENT_DIR=
set NEXT_LOCK_DIR=
set DEVICE_LOG=

REM check for safe boot 
if not "%1"=="" goto SAVEMODE
%CEDRV%\loadcepc.exe %CEDRV%\nk.bin
goto END

:SAVEMODE
%CEDRV%\loadcepc.exe /D:2 /L:800x600x16 %CEDRV%\nk.bin

:END
set CEDRV=
set RSDRV=
